const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const ledger_entries = sequelize.define(
    'ledger_entries',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

entry_reference: {
        type: DataTypes.TEXT,
      
      

      },

entry_date: {
        type: DataTypes.DATE,
      
      

      },

entry_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"commitment",


"obligation",


"invoice",


"payment",


"adjustment",


"reversal"

        ],

      },

currency: {
        type: DataTypes.ENUM,
      
      

        values: [

"CDF",


"USD"

        ],

      },

debit_amount: {
        type: DataTypes.DECIMAL,
      
      

      },

credit_amount: {
        type: DataTypes.DECIMAL,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

record_type: {
        type: DataTypes.TEXT,
      
      

      },

record_key: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  ledger_entries.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




















































//end loop



    db.ledger_entries.belongsTo(db.organizations, {
      as: 'organization',
      foreignKey: {
        name: 'organizationId',
      },
      constraints: false,
    });

    db.ledger_entries.belongsTo(db.fiscal_years, {
      as: 'fiscal_year',
      foreignKey: {
        name: 'fiscal_yearId',
      },
      constraints: false,
    });




    db.ledger_entries.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.ledger_entries.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return ledger_entries;
};


